function Vett_Ric=Det_Vett_Ric(Matrice_Circ,Matrice_Staz)

% questa funzione determina un vettore di dim Num_Staz contenente gli indici che arrivano alla stazione i-esima
% Matrice_Staz punta a Matrice_Circ. Se alla colonna puntata della Matrice_Circ 
% ci sono pi di un valore diverso da 0 allora c' collisione.

Num_Staz=length(Matrice_Staz);
Num_Circ=size(Matrice_Circ,2);
sum_out=[];
out=[];
for i=1:Num_Staz
   Matrice_Staz_i=Matrice_Staz(i,:);
   for j=Matrice_Staz_i,
      	if ((j~=0) & (j<=Num_Circ)),
         	out=[out; Matrice_Circ(i,j)];
      	elseif (j==0),
         	out=[out; Matrice_Circ(i,1)];
      	else
         	out=[out; 0];
         end  
   end
   % se out  diverso da 0 e sum_out  diverso da 0 allora c' collisione
   % lo stesso elemento di out rispetto a sum_out deve essere diverso da 0 per esserci collisione   
   
   for i=1:length(out),
       if ~isempty(sum_out),
        if (sum_out(i)~=0) & (out(i)~=0),
           sum_out(i)=99999;     % questo significa che c' stata collisione: la stazione i non riceve l'indice.
        end
       end
   end
   
   if ~isempty(sum_out),
      sum_out = sum_out+out;
   else
      sum_out = out;
   end
   out=[];
   
end   

Vett_Ric=sum_out;