function [Matrice_Pacc_Ric_AP,Time_Arrivo,Num_Coll]=fase_DCF(...
   Tc,Tc_prov,P_BS,T_PCF,Rate_Ass,Circ_X_m,Range_Max,Dim_pack,Dim_ACK, ...
   T_superframe,Matrice_Pacchetti,haTRASM_BS,DimMAX_Matrice_PAcchetti,passo_visualizzazione,...
   t_TRASM_MAX)


C                        = 300000000;   %   Velocit della luce uguale a 300000 Km/s
Num_BS                   = size(P_BS,1); 
Num_Circ                 = ceil(Circ_X_m*Range_Max);
tSLOT                    = 1/(Circ_X_m*C);
[Rate_Eff, Char_Circ]    = num_char_rate(Rate_Ass,Circ_X_m);
Matrice_Circ             = zeros(Num_BS,Num_Circ);
Matrice_Visibilita       = det_MATR_VISIBILITA(P_BS,Range_Max);



tDIFS        =   68E-6;
% t_TRASM_MAX  = 28E-6;        % tempo di attesa massimo dell'ACK da parte 
                               % delle BS da quando parte il pacchetto
                               % oltre il quale si presume che si sia verificata una collisione
T_SIM=T_PCF;                               
                               
                               
%  --------------------------------------------------------------------------------------------------


T_max_DCF = T_superframe-T_PCF;		% durata massima della fase DCF
tBACKOFF  = zeros(Num_BS,1);			% vettore che indica gli intervalli di Backoff scelti da ogni BS

BS_finite = zeros(Num_BS,1);        % vettore delle BS che hanno trasmesso i loro dati

InitTRASM_BS = zeros(Num_BS,1);		% vettore che indica quale delle BS pu trasmettere quando viene
												% rilevato libero il canale ed  trascorso l'intervallo di backoff
                                    
haTRASM_BS(1) = 1;                  % chi ha trasmesso non deve pi partecipare alla trasmissione
                                    % l'AP non deve partecipare alla trasmissione


Can_Occupato = zeros(Num_BS,1);     % vettore che indica quale BS sente il canale libero
                                    
t=0;			                  		% variabile che indica il passo temporale

for i=1:Num_BS		               	% creazione del vettore della lista delle BS che devono inviare dati
   BS_List(i)=i;
end


Dim_blank=DimMAX_Matrice_PAcchetti;
for i=1:Dim_blank,
   stringa_blank(i)=' ';   
end

Matr_Pacc_RIC=[];
for i=1:Num_BS,
   Matr_Pacc_RIC=[Matr_Pacc_RIC;stringa_blank];
end


Stream              =  zeros(Num_BS,1);         % nuova colonna generata dai trasmettitori
tNEXT1              =  0;                       % tempo incrementale utile per rappresentare il DIFS
tNEXT2              =  zeros(Num_BS,1);         % tempo incrementale utile valutare il tempo massimo di trasmissione
ha_trasm            =  zeros(Num_BS,1);         % vettore i cui elementi non rit a 0 anche dopo la trasm
Vett_Trasm          =  zeros(Num_BS,1);         % vettore che indica chi ha il concesso di trasmettere
Matrice_Staz        =  matrix_liv_circ(Circ_X_m,P_BS,Range_Max);  
Vett_block          =  zeros(Num_BS,1); 
Matr_Pacc_RIC       =  Matrice_Spazi(Num_BS,DimMAX_Matrice_PAcchetti);   % matrice di stringhe dei dati ricevuto dalle varie stazioni
Vett_Ric            =  zeros(Num_BS,1);
isACK               =  zeros(Num_BS,1);
Start               =  ones(Num_BS,1);          % valore che si azzera dopo il primo passaggio nel ciclo
Ricevente           =  ones(Num_BS,1);
Vedi_RISC_ACK       =  zeros(Num_BS,1);
Matrice_Pacc_Ric_AP =  [];
Pacchetto           =  [];
Cont_Cicli          =  0;
Num_Coll            =  0;
Time_Arrivo         =  [];
% ---------------------------------------------------------------------------------------------------


CW_max         = 32;		       		% dimensione massima di una CW (multipla di uno slot time)
CW_min         = 16;		        		% dimensione minima di una CW	(multipla di uno slot time)
MAX_CW			= 4096;	   		   % massimo valore possibile per la CW
tBACKOFF       = round((CW_max-CW_min)*rand(Num_BS,1)+CW_min).*(~haTRASM_BS);	
STRINGA=['CW= [', num2str([CW_min CW_max]),']   ...valori di tBACKOFF=[ 'num2str(tBACKOFF'),' ]'];disp(STRINGA)

for t=0:tSLOT:T_max_DCF,

   % incremento dei tempi incrementali oltre al tempo della simulazione.
   % da fare prima di interrogare le BS.

   tNEXT1     = tNEXT1+tSLOT;
   tNEXT2     = tNEXT2+tSLOT;
   T_SIM      = T_SIM +tSLOT;
   Cont_Cicli = Cont_Cicli + 1;
   if (mod(Cont_Cicli,floor(passo_visualizzazione*Circ_X_m))==0),
      Tempo_Corrente=['Tc: ',num2str(Tc),' + ',num2str(T_SIM+Tc_prov),' s']; disp(Tempo_Corrente)
   end
   Matrice_Circ=spostamento_segnale(Matrice_Circ,Stream);

   for i=1:Num_BS,
      if InitTRASM_BS(i)==1,
         Can_Occupato=val_Canale(Vett_Ric,Matrice_Visibilita,Can_Occupato);
         if ((Rilevatore_D(Matr_Pacc_RIC(Ricevente(i),:))==1) | (Start(i)==1)),  % il pacchetto   arrivato oppure
            Start(i) = 0;
            Vett_Ric     = zeros(Num_BS,1);
            Stream       = zeros(Num_BS,1);
            ha_trasm     = zeros(Num_BS,1);
            Vett_block   = zeros(Num_BS,1);
            Vett_Trasm   = zeros(Num_BS,1);
            Matrice_Circ = zeros(Num_BS,Num_Circ);
            if (isACK(i)==0),
               if (Vedi_RISC_ACK(i) == 1),
                  % cosa fare dopo l'ACK
                  InitTRASM_BS        = zeros(Num_BS,1);
                  Can_Occupato        = zeros(Num_BS,1);
                  Vett_Trasm          = zeros(Num_BS,1);
                  haTRASM_BS(i)       = 1;
                  tNEXT1              = 0;
                  Vedi_RISC_ACK(i)    = 0;
                  Matrice_Pacc_Ric_AP = [Matrice_Pacc_Ric_AP;Pacchetto_AP];
                  Time_Arrivo         = [Time_Arrivo,T_SIM];
               else
                  Matrice_Pacchetti(1,:) = crea_pacchetto(1,i,Dim_ACK,DimMAX_Matrice_PAcchetti);
                  Ricevente(i)  = 1;
                  Vett_Trasm(i) = 1;  
                  Vett_Trasm(1) = 0;
                  isACK(i)      = 1;
               end   
            else
                Ricevente(i)    = i; 
                Vett_Trasm(i)   = 0;
                Vett_Trasm(1)   = 1;
                isACK(i)        = 0;   
                Vedi_RISC_ACK(i)= 1;
                Pacchetto_AP=Matr_Pacc_RIC(1,:);
             end
             Matr_Pacc_RIC = Matrice_Spazi(Num_BS,DimMAX_Matrice_PAcchetti); 
    		end         
         [Stream,ha_trasm]=Stream_New(Matrice_Pacchetti,Stream,ha_trasm,Vett_Trasm,Rate_Ass,Circ_X_m);
         Vett_Ric=Det_Vett_Ric(Matrice_Circ,Matrice_Staz); 
         Vett_Ric=filtro_Vett_Ric( Vett_Ric, Matrice_Visibilita);
         [Matr_Pacc_RIC,Vett_block]=...
            crea_Matrice_Pacc_Ric(Vett_Ric,Matrice_Pacchetti,Char_Circ,Matr_Pacc_RIC,Vett_block);
         if (tNEXT2(i)>t_TRASM_MAX),
            CW_max        = CW_max*2;
            if CW_max>MAX_CW
               CW_max=MAX_CW;
            end
            tBACKOFF      = round ((CW_max-CW_min)*rand(Num_BS,1)+CW_min).*(~haTRASM_BS);
            STRINGA=['PRESENZA COLLISIONE!!!  ...nuova CW= [', num2str([CW_min CW_max]),']   ...nuovi valori di tBACKOFF=[ 'num2str(tBACKOFF'),' ]'];disp(STRINGA)
            InitTRASM_BS  = zeros(Num_BS,1);
            Can_Occupato  = zeros(Num_BS,1);
            ha_trasm      = zeros(Num_BS,1);
            Vett_Trasm    = zeros(Num_BS,1);
            isACK         = zeros(Num_BS,1);
            tNEXT2        = zeros(Num_BS,1);
            Start         = ones(Num_BS,1);
            Num_Coll      = Num_Coll+1;
         end
      else
         if tNEXT1>tDIFS,
            if ~(haTRASM_BS(i)),
               if ~(Can_Occupato(i)),
                  if tBACKOFF(i)==0, 
                     InitTRASM_BS(i)=1;
                     tNEXT2(i)=0;
                  else
                     tBACKOFF(i)=tBACKOFF(i)-1;    
                  end
               end
            end
         end
      end     
   end
end
