function [Matrice_Finale_BS,BS_NonTrasmette,T_PCF,Location_List_Rim,Num_Staz_BS_ric]=fase_PCF(...
   Tc,Tc_prov,P_MT,P_BS,Rate_Ass,Circ_X_m,Range_Max,Dim_pack,Dim_ACK,DimMAX_Matrice_PAcchetti,...
   passo_visualizzazione,Location_List,Num_Staz_BS_ric_old)


C                        = 300000000;   %   Velocit della luce uguale a 300000 Km/s
Pos_Staz                 = [P_BS;P_MT]; 
Num_MT                   = size(P_MT,1); 
Num_BS                   = size(P_BS,1); 
Num_Staz                 = Num_MT+Num_BS;
Num_Circ                 = ceil(Circ_X_m*Range_Max);
isBS                     = [ones(Num_BS,1);zeros(Num_MT,1)];
tSLOT                    = 1/(Circ_X_m*C);
[Rate_Eff, Char_Circ]    = num_char_rate(Rate_Ass,Circ_X_m);
Matrice_Pacchetti_AP     = [];
Matrice_Pacchetti        = [];
Matrice_Tempi            = [];
Ricevente                = 0;
Matrice_Circ             = zeros(Num_Staz,Num_Circ);
Vett_Ripetiz             = zeros(Num_Staz,1);         
% Vettore utile per far ripetere 3 volte una stazione nel momento in cui questa


% La Location_List continene gli indici dei terminali mobili: il primo elem contiene 
% l'indice del primo MT che sar considerato nella PCF
%  una matrice dinamica anche nelle dimensioni                      

if (~isempty(Location_List))
   for i=1:length(Location_List),
      Matrice_Pacchetti_AP=[Matrice_Pacchetti_AP;  crea_pacchetto(1,Location_List(i),Dim_pack, ...
            DimMAX_Matrice_PAcchetti)];
   end
end

Dim_blank=DimMAX_Matrice_PAcchetti;
for i=1:Dim_blank,
   stringa_blank(i)=' ';   
end

% il pacchetto totale comprende: S_  _D  e NNNN per gli indirizzi   
% Il numero delle Circ dipende dalla risoluzione cio di quante Circ sono presenti in un metro
% e dall'ambiente in cui ci troviamo. 

%%%%%% potrebbe essere una variabile di ingresso 
for ii=1:Num_Staz,
   Matrice_Pacchetti=[Matrice_Pacchetti;stringa_blank];   % Matrice_Pacchetti completamente vuota.
end         

Matr_Pacc_RIC=[];
for i=1:Num_Staz,
   Matr_Pacc_RIC=[Matr_Pacc_RIC;stringa_blank];
end


Matrice_Staz   =  matrix_liv_circ(Circ_X_m,Pos_Staz,Range_Max);  

Cont_Cicli = 0;
T_PCF  = 0;
tBEACON= 14/Rate_Ass;
tEND = 14/Rate_Ass;
tNEXT1 = 0;                                    % tempo incrementale utilizzato per il BEACON

tSIFS=28E-6;
tNEXT2=0;                                      % tempo incrementale utilizzato per il SIFS AP->MTi
tNEXT3=0;                                      % tempo incrementale utilizzato per il SIFS MTi->AP

tPIFS=48E-6;
t_PCF_MAX      =  1e-3-(tBEACON+tSIFS+tEND);                                                                                           
Exit_PCF       =  0;                                            


while (~isempty(Location_List) & (Exit_PCF~=1)),
   
  
 % Pacchetto dall'AP all' MTi
   
 tNEXT2         =  0;
 tNEXT3         =  0; 
 InvioACK       =  1;                         % flag utile per capire se c' l'invio dell'ACK
                                              % forse  meglio settarlo a 0 per poi metterlo a 1 quando 
                                              % si verificano determinate condizioni 
 
 Stream         =  zeros(Num_Staz,1);         % nuova colonna generata dai trasmettitori
 ha_trasm       =  zeros(Num_Staz,1);         % vettore i cui elementi non rit a 0 anche dopo la trasm
 Vett_Trasm     =  zeros(Num_Staz,1);         % vettore che indica chi ha il concesso di trasmettere
 Vett_block     =  zeros(Num_Staz,1);         % indica quali staz non devono ricevere il pacch 0:riceve 1:non riceve     
 Vett_Trasm(1)  =  1;                         % sta trasmettendo l'AP
 Matr_Pacc_RIC  =  Matrice_Spazi(Num_Staz,DimMAX_Matrice_PAcchetti);   % matrice di stringhe dei dati ricevuto dalle varie stazioni
 Sum_Vett_TR    =  zeros(Num_Staz,1);         % vettore utile per capire se una data stazione ha ricevuto il pack    
 Sum_Vett_Ris   =  zeros(Num_Staz,1);         % vettore utile per capire se una data stazione ha ricevuto il pack     
 Blocco_PIFS    =  0;                         % flag che va a uno che c' il suparamento del 
                                              % tPIFS nenza aver ricevuto l'ACK
                                              % non pu mai ricevere il pacchetto perch troppo lontana
                                              % vettore dei tempi di arrivo dei pacchetti alle stazioni riceventi   
 Vett_t         =  zeros(Num_Staz,1);         
 tPROP          =  0;                         % tempo di propagazione da MTi => BSi + tSIFS + tESTR_PACCHETTO_AP
 Tc_prov        =  tBEACON + tSIFS;
 
 if (Ricevente~=0)
    Vett_Trasm(Ricevente)  =  0;
 end      
 Ricevente      =  Location_List(1);
 Matrice_Pacchetti(1,:)=Matrice_Pacchetti_AP(1,:);
 
 if (length(Location_List)>=2),
     Num_MT_Rim =  length(Location_List);
     Location_List=Location_List(2:Num_MT_Rim);
     Matrice_Pacchetti_AP=Matrice_Pacchetti_AP(2:Num_MT_Rim,:);
 else
     Location_List=[];
     Matrice_Pacchetti_AP=[];
  end
  
 Stringa=['a  Tc=',num2str(Tc),' + ',num2str(T_PCF+Tc_prov),' s ... inizia la trasmissione da AP a MT',num2str(Ricevente-Num_BS)];disp(Stringa); 
 
 t=0;     % variabile che indica il passo temporale
 
     
 while ((tNEXT2<=tSIFS) & (Exit_PCF~=1)),
      Matrice_Visibilita = det_MATR_VISIBILITA(Pos_Staz,Range_Max); 
   	t      = t+tSLOT;
      tNEXT1 = tNEXT1+tSLOT;
      Cont_Cicli = Cont_Cicli + 1;
      if (mod(Cont_Cicli,floor(passo_visualizzazione*Circ_X_m))==0),
         Tempo_Corrente=['Tc: ',num2str(Tc),' + ',num2str(T_PCF+Tc_prov),' s']; disp(Tempo_Corrente)
      end 
      if (tNEXT1>=tBEACON+tSIFS),
         T_PCF  = T_PCF+tSLOT; 
         if (T_PCF>=t_PCF_MAX)  % eseguire il controllo per l'invio del pacchetto di END
            Exit_PCF=1; 
            Location_List  =  [Ricevente,Location_List];
         end
         tPROP=tPROP+tSLOT;
         [Stream,ha_trasm]=Stream_New(Matrice_Pacchetti,Stream,ha_trasm,Vett_Trasm,Rate_Ass,Circ_X_m);    
    		Sum_Vett_TR = Sum_Vett_TR + real(Stream);
         if ((Sum_Vett_TR(1)~=0) & (Stream(1)==0)),  % modo per capire che  finita la trasmisione da parte dell'AP
            tNEXT2=tNEXT2+tSLOT;
    		end     
    		Matrice_Circ=spostamento_segnale(Matrice_Circ,Stream);  
          Vett_Ric=Det_Vett_Ric(Matrice_Circ,Matrice_Staz);
          Vett_Ric=filtro_Vett_Ric( Vett_Ric, Matrice_Visibilita);
         [Matr_Pacc_RIC,Vett_block]=...
                  crea_Matrice_Pacc_Ric(Vett_Ric,Matrice_Pacchetti,Char_Circ,Matr_Pacc_RIC,Vett_block);
   	end  
 	end
    
   Stringa=['a  Tc=',num2str(Tc),' + ',num2str(T_PCF+Tc_prov),' s ... il pacchetto partito da AP  arrivato a MT',num2str(Ricevente-Num_BS)];disp(Stringa); 
   Stringa=['inizia ora la risposta con l''ACK'];disp(Stringa);
 
   % modifica della Matrice_Pacchetti con l'ACK di risposta  
    
   % risposta ACK
      
   Matrice_Pacchetti(Ricevente,:) = crea_pacchetto(Ricevente,99,Dim_ACK,DimMAX_Matrice_PAcchetti);
 
  Vett_block             =  zeros(Num_Staz,1);
  Vett_t                   =  zeros(Num_Staz,1);         
 	Vett_Trasm(1)          =  0;
 	Vett_Trasm(Ricevente)  =  1;
    
   Pacchetto_Trasmesso=Matr_Pacc_RIC(Ricevente,:);
   if (Pacchetto_Trasmesso==stringa_blank),
      InvioACK=0;
      disp('la stazione  molto lontana.')
   else  
     if ~isempty(find(Pacchetto_Trasmesso=='X'))
       if  (sum(find(Pacchetto_Trasmesso=='X')==0)==0),
         InvioACK=0;
         disp('presenza di disturbo nella trasmissione.')   
      end
    end  
   end 
   Matr_Pacc_RIC; 
 	Matr_Pacc_RIC=Matrice_Spazi(Num_Staz,DimMAX_Matrice_PAcchetti);
    
   % vettore utile per capire quando un trasmettotore ha finito di trasmettere
   Sum_Vett_TR    =  zeros(Num_Staz,1);       
   
   % vettore utile per capire se una data stazione ha ricevuto il pack
   Sum_Vett_Ris   =  zeros(Num_Staz,1);       
    
   


% non sempre si deve riinviare l'ack...
% se non arriva il pacchetto oppure nel pacchetto  presente 
% una X l'ack non deve essere spedito e si passa alla trasmissione
% successiva mettendo nella location list la stazione che presenta questo problema
  
  while ((tNEXT3<=tSIFS) & (Blocco_PIFS==0) & (Exit_PCF~=1)),
      Matrice_Visibilita = det_MATR_VISIBILITA(Pos_Staz,Range_Max); 
   	t=t+tSLOT; 
   	tNEXT2=tNEXT2+tSLOT;
      tPROP=tPROP+tSLOT;
      T_PCF  = T_PCF+tSLOT;
      Cont_Cicli = Cont_Cicli + 1;
      if (mod(Cont_Cicli,floor(passo_visualizzazione*Circ_X_m))==0),
         Tempo_Corrente=['Tc: ',num2str(Tc),' + ',num2str(T_PCF+Tc_prov),' s']; disp(Tempo_Corrente)
      end
      if (T_PCF>=t_PCF_MAX)  % eseguire il controllo per l'invio del pacchetto di END
         Exit_PCF=1; 
         Location_List  =  [Ricevente,Location_List];
      end
   	[Stream,ha_trasm]=Stream_New(Matrice_Pacchetti,Stream,ha_trasm,Vett_Trasm,Rate_Ass,Circ_X_m);    
   	Sum_Vett_TR = Sum_Vett_TR + real(Stream);
      
      % avanzamento del tNEXT3 dopo che  finita la trasmissione...
      if ((Sum_Vett_TR(Ricevente)~=0) & (Stream(Ricevente)==0)),  
         tNEXT3=tNEXT3+tSLOT;
   	end 
   	Matrice_Circ=spostamento_segnale(Matrice_Circ,Stream);  
   	Vett_Ric=Det_Vett_Ric(Matrice_Circ,Matrice_Staz);
      Vett_Ric=filtro_Vett_Ric( Vett_Ric, Matrice_Visibilita);
      Vett_Ric=Vett_Ric.*isBS;
      Sum_Vett_Ris = Sum_Vett_Ris + real(Vett_Ric);
   
      % parte di codice utile utiler per capire cosa fare dopo il tempo PIFS...
      if (((tNEXT2>=tPIFS) & (InvioACK==0)) | ((tNEXT2>=tPIFS) & (Sum_Vett_Ris(1)==0)))
      	Blocco_PIFS=1;
      	Location_List=[Location_List Ricevente];
      	Matrice_Pacchetti_AP=[Matrice_Pacchetti_AP; Matrice_Pacchetti(1,:)];
   	end
      
      
      % non  importante per la trasmissione serve solo per la valutazione dei tempi di risposta...
      Vett_t=Es_Val_Time_Arrivo(tPROP,Vett_Ric,Vett_t);    
      
      [Matr_Pacc_RIC,Vett_block]= ...
         crea_Matrice_Pacc_Ric(Vett_Ric,Matrice_Pacchetti,Char_Circ,Matr_Pacc_RIC,Vett_block); 
      
   end
   
   Stringa=['a Tc=',num2str(Tc),' + ',num2str(T_PCF+Tc_prov),' s...  l''ACK  inviato in broadcast da MT',num2str(Ricevente-Num_BS),'  arrivato all''AP'];disp(Stringa); 
%   Stringa=['si prosegue adesso con la trasmissione del pacchetto al teminale mobile successivo'];disp(Stringa);
   


tNEXT4 = 0;
Sum_Vett_TR2=0;
ha_trasm       =  zeros(Num_Staz,1);         % vettore i cui elementi non rit a 0 anche dopo la trasm
Vett_Trasm     =  zeros(Num_Staz,1);         % vettore che indica chi ha il concesso di trasmettere
Sum_Vett_TR    =  zeros(Num_Staz,1);
Vett_Trasm(1)  =  1;
Matrice_Pacchetti(1,:) = crea_pacchetto(99,1,Dim_ACK,DimMAX_Matrice_PAcchetti);
while (tNEXT4<=tSIFS),
      Matrice_Visibilita = det_MATR_VISIBILITA(Pos_Staz,Range_Max); 
   	[Stream,ha_trasm]=Stream_New(Matrice_Pacchetti,Stream,ha_trasm,Vett_Trasm,Rate_Ass,Circ_X_m);    
         	Sum_Vett_TR2 = Sum_Vett_TR2 + real(Stream);
      % avanzamento del tNEXT3 dopo che  finita la trasmissione...
      if ((Sum_Vett_TR2(1)~=0) & (Stream(1)==0)),  
      	tNEXT4=tNEXT4+tSLOT;
   	end 
      Matrice_Circ=spostamento_segnale(Matrice_Circ,Stream);  
   	Vett_Ric=Det_Vett_Ric(Matrice_Circ,Matrice_Staz);
      Vett_Ric=filtro_Vett_Ric(Vett_Ric, Matrice_Visibilita);
      Vett_Ric=Vett_Ric.*isBS;    
      [Matr_Pacc_RIC,Vett_block]= ...
         crea_Matrice_Pacc_Ric(Vett_Ric,Matrice_Pacchetti,Char_Circ,Matr_Pacc_RIC,Vett_block);     
end

                
% fornisce il pacchetti giunti alle stazioni riceventi
%disp('*****************************')
%disp('PACCHETTI GIUNTI ALLE BS:')
%disp(Matr_Pacc_RIC)
%disp('*****************************')


Num_Staz_BS_ric=[Num_Staz_BS_ric_old;Size_without_blank(Matr_Pacc_RIC)];

% determinazione fisica del tempo  di propagazione di ritorno
if (InvioACK~=0),
  if (sum(Vett_t)~=0),
    Time_Tp       = Vett_t-tSIFS-length(string_without_blank(Matrice_Pacchetti(1,:)))/Rate_Eff;
    Matrice_Tempi = crea_Matrice_Finale_PCF(Time_Tp(1:Num_BS),Matrice_Tempi);
  end
end 
 
 % matrice dei soli tempi utili per essere trasferiti nella fase DCF

end

dim_stringa=Dim_pack-size(Matrice_Tempi,2);

if (dim_stringa<0),
   dim_stringa=0;
end

Matrice_Finale_BS=[];
BS_NonTrasmette=zeros(Num_BS,1);

  if ~isempty(Matrice_Tempi),
    Stringa_trattini='';
    for j=1:size(Matrice_Tempi,2)
      Stringa_trattini=[Stringa_trattini,'-'];
    end
  end

  for i=1:Num_BS,
    if ~isempty(Matrice_Tempi),
       Matrice_Finale_BS=[Matrice_Finale_BS;crea_Pacchetto_DCF_with_time(i,1,Matrice_Tempi(i,:),...
                                                          dim_stringa,DimMAX_Matrice_PAcchetti)];  
       if (Matrice_Tempi(i,:)==Stringa_trattini),
          BS_NonTrasmette(i)=1;   
       end   
    else
       Matrice_Finale_BS=[Matrice_Finale_BS;crea_Pacchetto_DCF_with_time(i,1,[],dim_stringa,...
                                                                       DimMAX_Matrice_PAcchetti)];
       BS_NonTrasmette(i)=1;
    end
  end

Location_List_Rim=Location_List;

