
%  (X,Y) dei terminali mobili
P_MT = [[-15,-15];[-10,-12];[-6,-6];[5,-11];[14,-15];[-14,0];[-7,3];[3,1];[8,2];[15,0]];

%  (X,Y) dell'AP e delle BS
P_BS = [[0,0];[-7,-13];[7,-13];[14,0];[7,13];[-7,13];[-14,0]];

Rate_Ass                 = 750000;      %   rate del segnale [char/s]
Circ_X_m                 = 0.05;        %   numero di circonferenze per m (il valore pi piccolo  0.05)
Range_Max                = 25;          %   range massimo per ogni trasmettitore [m]
Dim_pack                 = 42;          %   Dimensione del pacchetto di Location Update Request inviato dall'AP al MT
                                        %   42+8=50(400bit), 8 caratteri servono l'inizio e la fine del pacchetto e per gli ID  
Dim_ACK                  = 6;           %   Dimensione del pacchetto di ACK
													 %   6+8=14 (112bit)
Dim_pack_stime				 = 30+6*size(P_MT,1);		% Dimensione del pacchetto con le stime del TOA inviato dalle BS all'AP
																	% 30+6*(#MT)+8 (minimo 44 = 352 bit)               

DimMAX_Matrice_PAcchetti = 200;                                        

T_superframe             = 0.005;
tSIFS							 = 28e-06;

passo_visualizzazione=20000;
t_TRASM_MAX =  (Dim_pack_stime+8)/Rate_Ass + tSIFS;		%  tempo di attesa massimo dell'ACK da parte delle BS da quando parte il pacchetto
                              						         %  oltre il quale si presume che si sia verificata una collisione
	

T_simulazione = 7;   		% questo tempo sar pari a quello impiegato dal MT per compiere il
									   % suo percorso prestabilito (valore di prova 0.02)
T_poll        = 0.5;  		% rate di interrogazione dei MT in secondi (valore di prova 0.01)
                                                                                 
V_MT          = 2;        % velocit di spostamento del mobile in m/s 



save variabili.mat

