function [Matr_Pacc_RIC,Vett_block]=crea_Matrice_Pacc_Ric(Vett_Ric,Matrice_Pacchetti,num_char_x_circ,Matr_Pacc_RIC_Old,Vett_block_old)

% Matr_Pacc_RIC rappresenta una matrice contenente i buffer ('striga di caratteri') di ricezione di tutte le stazioni
% Vett_Ric rappresenta l'indice che  arrivaro alla stazione i-esima
% Vett_block  un vettore i cui elementi sono uguali a 1 se c' collisione
% per collisione si intende l'arrivo contemporaneo di due pacchetti alla stazione i


  Num_Staz=size(Matrice_Pacchetti,1);
  Dim_blank=size(Matrice_Pacchetti,2);
  Vett_block=Vett_block_old;
  for i=1:Dim_blank,
     		stringa_blank(i)=' ';   
  end
  if isempty(Matr_Pacc_RIC_Old),
  		Matr_Pacc_RIC=[];  
  		for i=1:Num_Staz,
     		Matr_Pacc_RIC=[Matr_Pacc_RIC;stringa_blank];
      end
  else
      Matr_Pacc_RIC=Matr_Pacc_RIC_Old;
  end

  for i=1:length(Vett_Ric),
      if (Vett_Ric(i)~=0),
         indice=real(Vett_Ric(i));
         staz=imag(Vett_Ric(i));
         out=slot(num_char_x_circ,Matrice_Pacchetti(staz,:),indice);        
         if ~isempty(out),
            pp=floor(rand+0.001);   % introduzione di un rumore nel segnale ricevente
            if (pp==1);
               out='X';
%              disp('Inserimento Rumore');
            end
         end
         row_old=Matr_Pacc_RIC(i,:);
         row_old_filtr=string_without_blank(row_old);
         row_new=[row_old_filtr out row_old(length(row_old_filtr)+length(out)+1:length(row_old))];
         Matr_Pacc_RIC(i,:)=row_new(1:Dim_blank);
         ind_dest_pacc=Estrazione_indice(Matr_Pacc_RIC(i,:),1);
         if (((ind_dest_pacc~=i) & (ind_dest_pacc~=0) & (ind_dest_pacc~=99)) | ...
               (Vett_block_old(i)==1) | (Vett_Ric(i)>99999) | (ind_dest_pacc==98) ),
            Matr_Pacc_RIC(i,:)=stringa_blank;
            Vett_block(i)=1;
         end
      end
  end
