function P_MT_next=percorso_breve4(t,v,P_MT)

% crea un percorso breve all'interno di una griglia rettangolare di 32m x 32m

%v    : velocit del MT in m/s		 
%t    : Distanza Temporale che indica ogni quanto viene calcolata la nuova posizione
%P_MT : Matrice delle posizioni iniziali dei terminali mobili


P_MT_next=zeros(size(P_MT));

for i=1:size(P_MT,1),
   xi=P_MT(i,1);
   yi=P_MT(i,2);
   
   x=xi- v*t;       % funzione  parametrica che definisce il percorso
   y=yi;           
   
   P_MT_next(i,1)=x;
   P_MT_next(i,2)=y;
end




 


