% Dobbiamo inserire il numero di BS (insieme alla posizione AP). Ogni BSi sar una riga di una matrice. 
% La prima riga  l'AP

format short e

Num_MT   = size(P_MT,1);
Num_BS   = size(P_BS,1);
for i=1:Num_MT,
   Location_List_Ini(i)=Num_BS+i;
end

Location_List=Location_List_Ini;
Time_Arrivo_TOT2=[];
Time_Arrivo_TOTF=[];
Num_Staz_BS_ric_TOT=[];
Num_Pacc_Ric_AP_TOT=[];
Num_Coll_DCF_TOT=[];
Ricezioni_TOT=[];
Ricezioni_con_Successo=[];
PASSAGGIO=1;

disp('*-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-*');   
disp('                                INIZIO DELLA SIMULAZIONE');
disp('*-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-**-*-*-*-*  ');  
   
disp(' ')
disp(' ')
disp(' ')   
disp('Posizione BS:')
for i=1:size(P_BS,1),
      VALX=num2str(P_BS(i,1));
      if (length(VALX)==1),
         VALX=['   ',VALX];
      elseif (length(VALX)==2),
         VALX=['  ',VALX];
      elseif (length(VALX)==3),
         VALX=[' ',VALX];   
      end
      VALY=num2str(P_BS(i,2));
      if (length(VALY)==1),
         VALY=['   ',VALY];
      elseif (length(VALY)==2),
         VALY=['  ',VALY];
      elseif (length(VALY)==3),
         VALY=[' ',VALY];   
      end
      STRINGA=['BS',num2str(i),':   X:',VALX,'   Y:',VALY];
      disp(STRINGA);
end

for Tc = 0:T_poll:T_simulazione-T_poll;   % Tc  il tempo totale della simulazione
   
   Time_Arrivo_PROV       =[];
   Num_Staz_BS_ric_PROV   =[];
   Num_Pacc_Ric_AP_PROV   =[];
   Num_Coll_DCF_PROV      =[];
   Tc_prov                =0;
   j = 0;
   
   
   disp(' ')
   disp(' ')
   disp(' ')
   disp('********************************************************************************************');   
   STRINGA=['                              INIZIO TRASMISSIONE N ',num2str(PASSAGGIO),' AL TEMPO Tc: ',num2str(Tc),' s'];
   disp(STRINGA);
   disp('********************************************************************************************');   
   PASSAGGIO=PASSAGGIO+1;
   
   if Tc==0
      P_MT = percorso_breve3(0,V_MT,P_MT)
   else
      P_MT = percorso_breve3(T_poll,V_MT,P_MT)   
   end
   
   disp(' ')
   disp(' ')
   disp(' ')   
   disp('Posizione MT in questa trasmissione:')
   for i=1:size(P_MT,1),
      VALX=num2str(P_MT(i,1));
      if (length(VALX)==1),
         VALX=['   ',VALX];
      elseif (length(VALX)==2),
         VALX=['  ',VALX];
      elseif (length(VALX)==3),
         VALX=[' ',VALX];   
      end
      VALY=num2str(P_MT(i,2));
      if (length(VALY)==1),
         VALY=['   ',VALY];
      elseif (length(VALY)==2),
         VALY=['  ',VALY];
      elseif (length(VALY)==3),
         VALY=[' ',VALY];   
      end
      STRINGA=['MT',num2str(i),':   X:',VALX,'   Y:',VALY];
      disp(STRINGA);
   end
   
   disp(' ')
   disp(' ')
   STRINGA=[];
   for i=Location_List
     STRINGANEW=[' MT',num2str(i-Num_BS)];
     STRINGA=[STRINGA,STRINGANEW];
   end
   STRINGA=['MT presenti nella Location List: [', STRINGA,' ]'];disp(STRINGA);
   disp(' ')
   disp(' ')


   
   
   for T_super = 0:T_superframe:T_poll                             
      
      Num_Staz_BS_ric        =[];
      
      if (~isempty(Location_List)), 
         [Matrice_Finale_BS,BS_NonTrasmette,T_PCF,Location_List,Num_Staz_BS_ric] =  fase_PCF(Tc,Tc_prov,P_MT,P_BS,...
            Rate_Ass,Circ_X_m,Range_Max,Dim_pack,Dim_ACK,DimMAX_Matrice_PAcchetti,...
            passo_visualizzazione,Location_List,Num_Staz_BS_ric);
         
         disp('Pacchetti generati in ogni BS dopo la fase PCF');disp(Matrice_Finale_BS);
         disp(' ')
         
         STRINGA=[];
         for i=Location_List
            STRINGANEW=[' MT',num2str(i-Num_BS)];
            STRINGA=[STRINGA,STRINGANEW];
         end
         STRINGA=['MT presenti nella Location List: [', STRINGA,' ]'];disp(STRINGA);
         disp(' ')
            
         STRINGA=['Tempo impiegato dalla fase PCF in questo passaggio: ', num2str(T_PCF),' s'];disp(STRINGA);
         disp(' ')
         
         [Matrice_Pacc_Ric_AP,Time_Arrivo,Num_Coll]  =  fase_DCF(...
            Tc,Tc_prov,P_BS,T_PCF,Rate_Ass,Circ_X_m,Range_Max,Dim_pack_stime,Dim_ACK,...
            T_superframe,Matrice_Finale_BS,BS_NonTrasmette,DimMAX_Matrice_PAcchetti,...
            passo_visualizzazione,t_TRASM_MAX);
         
     if   (~isempty(Matrice_Pacc_Ric_AP)),     
         disp('Pacchetti giunti a AP da tutte le BS')
         disp(Matrice_Pacc_Ric_AP)
         disp(' ')

         Time_Arrivo_PROV            =[Time_Arrivo_PROV,T_super+Time_Arrivo];         
         
         Num_Staz_BS_ric_PROV        =[Num_Staz_BS_ric_PROV;Num_Staz_BS_ric];
         
         for i=1:size(Matrice_Pacc_Ric_AP,1)-1,
            if (Matrice_Pacc_Ric_AP(i,2)~= '_' ) 
                j = j+1;         % contatore dei pacchetti ricevuti corrotti in ogni DCF
            end
         end    
            
         Num_Pacc_Ric_AP = size(Matrice_Pacc_Ric_AP,1)-j;   
         Num_Pacc_Ric_AP_PROV = [Num_Pacc_Ric_AP_PROV;Num_Pacc_Ric_AP];
         
         Num_Coll_DCF_PROV           =[Num_Coll_DCF_PROV;Num_Coll];
     end        
     Tc_prov      = Tc_prov+T_superframe;
     Num_Coll_DCF_Superframe         = mean(Num_Coll_DCF_PROV);    
  
     end
   end
   Location_List= Location_List_Ini;
   
  if ~isempty(Time_Arrivo_PROV)   
    Time_Arrivo_TOT2            =[Time_Arrivo_TOT2;Time_Arrivo_PROV(2)];
    Time_Arrivo_TOTF            =[Time_Arrivo_TOTF;Time_Arrivo_PROV(length(Time_Arrivo_PROV))];
 
    Num_Staz_BS_ric_TOT         =[Num_Staz_BS_ric_TOT;Num_Staz_BS_ric_PROV];
    Num_Pacc_Ric_AP_TOT         =[Num_Pacc_Ric_AP_TOT;Num_Pacc_Ric_AP_PROV];
    Num_Coll_DCF_TOT            =[Num_Coll_DCF_TOT,Num_Coll_DCF_Superframe];
   
   
   
    Ricezioni_TOT=[Ricezioni_TOT;1];
    if (Num_Pacc_Ric_AP>=2),
       Ricezioni_con_Successo=[Ricezioni_con_Successo;1];
       disp('-----> LOCALIZZAZIONE AVVENUTA CON SUCCESSO! <-----')
    else
       Ricezioni_con_Successo=[Ricezioni_con_Successo;0];
       disp('-----> LOCALIZZAZIONE NON AVVENUTA CON SUCCESSO! <-----')
    end

     
    STRINGA=['Tempo di arrivo dei primi 2 pacchetti all''AP in questo passaggio: ',num2str(Time_Arrivo_PROV(2))];disp(STRINGA);     
    STRINGA=['Tempo di arrivo di tutti i pacchetti all''AP in questo passaggio : ',num2str(Time_Arrivo_PROV(length(Time_Arrivo_PROV)))];disp(STRINGA);   

 
    STRINGA=['Numero di BS disponibili per ogni MT in questo passaggio: ',num2str(mean(Num_Staz_BS_ric_PROV))];disp(STRINGA);        
    STRINGA=['Numero di pacchetti ricevuti dall''AP in questo passaggio: ',num2str(mean(Num_Pacc_Ric_AP_PROV))];disp(STRINGA);     
    STRINGA=['Numero collisioni nella fase DCF in questo passaggio: ',num2str(Num_Coll_DCF_Superframe)];disp(STRINGA);
           
  end   
   
   

   
end


% eseguire la media e la deviazione standard
% dell'ultima colonna del tempo di arrivo e della seconda colonna
disp(' ')
disp(' ')
disp(' ')
disp('---------------------------------------------------------------------------------------');
disp('-------------------         TABELLA RIASSUNTIVA FINALE         ------------------------');
disp(' ')

if (~isempty(Time_Arrivo_TOT2)),
 Media_TIME_ARR2=mean(Time_Arrivo_TOT2);
 Dev_Time_Arr2=std(Time_Arrivo_TOT2,1);
 STRINGA=['     Tempo medio di arrivo dei primi 2 pacchetti all''AP: ',...
         num2str(Media_TIME_ARR2),' +/- ',num2str(Dev_Time_Arr2),' s'];
 disp(STRINGA);
end

if (~isempty(Time_Arrivo_TOTF)),
 Media_TIME_ARR_ULTIMO=mean(Time_Arrivo_TOTF);
 Dev_Time_Arr_ULTIMO=std(Time_Arrivo_TOTF,1);
 STRINGA=['     Tempo medio di arrivo di tutti i pacchetti all''AP: ',...
         num2str(Media_TIME_ARR_ULTIMO),' +/- ',num2str(Dev_Time_Arr_ULTIMO),' s'];
 disp(STRINGA);
end

Media_Num_Staz_BS_ric =mean(Num_Staz_BS_ric_TOT);
Dev_Num_Staz_BS_ric   =std(Num_Staz_BS_ric_TOT,1);
STRINGA=['     Numero medio di BS disponibili per ogni MT: '...
   num2str(Media_Num_Staz_BS_ric),' +/- ',num2str(Dev_Num_Staz_BS_ric)];
disp(STRINGA);


Media_Num_Pacc_Ric_AP =mean(Num_Pacc_Ric_AP_TOT);
Dev_Num_Pacc_Ric_AP   =std(Num_Pacc_Ric_AP_TOT,1);
STRINGA=['     Numero medio di BS utilizzate: '...
   num2str(Media_Num_Pacc_Ric_AP),' +/- ',num2str(Dev_Num_Pacc_Ric_AP)];
disp(STRINGA);

Media_Coll_DCF         =mean(Num_Coll_DCF_TOT);
Dev_Coll_DCF           =std(Num_Coll_DCF_TOT,1);
STRINGA=['     Numero medio collisioni nella fase DCF: '...
   num2str(Media_Coll_DCF),' +/- ',num2str(Dev_Coll_DCF)];
disp(STRINGA);

Prob_successo=100*sum(Ricezioni_con_Successo)/sum(Ricezioni_TOT);
STRINGA=['     Probabilita media di successo della localizzazione: '...
   num2str(Prob_successo),' %'];
disp(STRINGA);

disp(' ')
disp('---------------------------------------------------------------------------------------');
disp('---------------------------------------------------------------------------------------');

