
%  (X,Y) dei terminali mobili
P_MT = [[0,-10]];

%  (X,Y) dell'AP e delle BS
P_BS = [[0,0];[-12,-13];[0,-13];[12,-13];[12,0];[12,13];[0,13];[-12,13];[-12,0]];

Rate_Ass                 = 1500000;     %   rate del segnale [char/s]
Circ_X_m                 = 0.05;        %   numero di circonferenze per m (il valore pi piccolo  0.05)
Range_Max                = 26;          %   range massimo per ogni trasmettitore [m]
Dim_pack                 = 42;          %   Dimensione del pacchetto di Location Update Request inviato dall'AP al MT
                                        %   42+8=50(400bit), 8 caratteri servono l'inizio e la fine del pacchetto e per gli ID  
Dim_ACK                  = 6;           %   Dimensione del pacchetto di ACK
													 %   6+8=14 (112bit)
Dim_pack_stime				 = 30+6*size(P_MT,1);		% Dimensione del pacchetto con le stime del TOA inviato dalle BS all'AP
																	% 30+6*(#MT)+8 = 44 (minimo 352 bit)               

DimMAX_Matrice_PAcchetti = 200;                                        

T_superframe             = 0.005;
tSIFS							 = 28e-06;

passo_visualizzazione=20000;
t_TRASM_MAX =  (Dim_pack_stime+8)/Rate_Ass + tSIFS;		%  tempo di attesa massimo dell'ACK da parte delle BS da quando parte il pacchetto
                              						         %  oltre il quale si presume che si sia verificata una collisione
	

T_simulazione = 25;   		% questo tempo sar pari a quello impiegato dal MT per compiere il
									% suo percorso prestabilito
T_poll        = 0.5;  		% rate di interrogazione dei MT in secondi
                                                                                 
V_MT          =2;        % velocit di spostamento del mobile in m/s 



save variabili.mat

